/* b4applic.c  (c)Copyright Sequiter Software Inc., 1987-1990. All rights reserved. */

#include "d4base.h"
#include "w4.h"

#include <string.h>

static FIELD  fields[] = 
{
   { "NAME",      'C', 25, 0, 0 },
   { "COMPANY",   'C', 25, 0, 0 },
   { "ADDRESS1",  'C', 40, 0, 0 },
   { "ADDRESS2",  'C', 40, 0, 0 },
   { "ADDRESS3",  'C', 40, 0, 0 },
   { "BIRTH_DATE",'D',  8, 0, 0 },
   { "SEX",       'C',  1, 0, 0 },
} ;

static long name_ref, company_ref, a1_ref, a2_ref, a3_ref, birth_ref, sex_ref ;
static char *birth_ptr ;

static int c1 =   2 ;
static int c2 =  12 ;

static int  browse_setup(void) ;
static int  browse_setup()
{
   /* Define an appropriate window. */
   w4define( 1,0, 24,39 ) ;
   w4border( DOUBLE, F_WHITE ) ;
   w4title( 0,-1, " Customer Database Browsing ", F_WHITE ) ;

   /* Standard calls for a browse setup routine. */
   w4memory() ;
   w4activate(-1) ;
   g4release(0) ;

   /* Define the screen layout. */
   w4( 1, 2, "Name" ) ;
   g4field( -1, 2, name_ref ) ;
   g4width( f4width(name_ref), 16 ) ;

   w4( 1,20, "Company" ) ;
   g4field( -1,20, company_ref ) ;
   g4width( f4width(company_ref), 16 ) ;

   return( w4select(-1) ) ;
}

static int  day(char *) ;
static int  day( char *dt )
{
   return( (int) c4atol(dt+6,2) ) ;
}

static int  month(char *) ;
static int  month( char *dt )
{
   return( (int) c4atol(dt+4,2) ) ;
}

static int  year(char *) ;
static int  year( char *dt )
{
   return( (int) c4atol(dt,4) ) ;
}

static int  cur_year, cur_month, cur_day ;

static int  age(void) ;
static int  age()
{
   int age_val ;

   age_val =  cur_year - year( birth_ptr ) - 1 ;
   if ( cur_month >= month( birth_ptr))
      if ( cur_month > month(birth_ptr) || cur_day >= day(birth_ptr) )
         age_val++ ;

   return age_val ;
}


static int  age_row ;
static int  display_age(int,int) ;
static int  display_age( int j1, int j2 ) 
{
   if ( *birth_ptr == ' ' )
      w4( age_row,c2, "   " ) ;
   else
      w4int( age_row,c2+15, age(), 3 ) ;

   return 0 ;
}

static int  sex_check(GET *) ;
static int  sex_check( GET *get_ptr )
{
   char sex ;

   memcpy( &sex, get_ptr->data, 1 ) ;
   if ( sex == 'M' || sex == 'F' || sex == ' ' )  return 0 ;

   w4display(" Entry Error ", "The sex must be 'M', 'F' or blank.", (char *) 0);

   return -1 ;
}


static int  edit_setup(void) ;
static int  edit_setup()
{
   /* Define an appropriate window. */
   w4define( 1,40, 24,79 ) ;
   w4border( DOUBLE, F_WHITE ) ;
   w4title( 0,-1, " Customer Database Editing ", F_WHITE ) ;

   /* Standard calls for a edit setup routine. */
   w4memory() ;
   w4activate(-1) ;
   g4release(0) ;

   /* Define the screen layout. */
   w4( 1,c1, "Name" ) ;
   g4field( w4row(),c2, name_ref ) ;

   w4( w4row()+1,c1, "Company" ) ;
   g4field( w4row(),c2, company_ref ) ;

   w4( w4row()+2,c1, "Address:" ) ;
   g4field( w4row()+1,c1, a1_ref ) ;
   g4width( f4width(a1_ref), 35 ) ;

   g4field( w4row()+2,c1, a2_ref ) ;
   g4width( f4width(a2_ref), 35 ) ;

   g4field( w4row()+3,c1, a3_ref ) ;
   g4width( f4width(a3_ref), 35 ) ;

   w4( w4row()+5,c1, "Birthday" ) ;
   g4field( w4row(),c2, birth_ref ) ;

   w4( w4row(),c2+12, "Age" ) ;
   b4call( display_age ) ;
   age_row =  w4row() ;

   w4( w4row()+1,c2, "MMM/DD/YY" ) ;

   w4( w4row()+2,c1, "Sex" ) ;
   g4field( w4row(),c2, sex_ref ) ;
   g4valid( sex_check ) ;
   g4picture( "!" ) ;

   return( w4select(-1) ) ;
}

main()
{
   char *ptr, match_data[14] ;
   int   rc ;

   /* This explicit initialization call is to make Code Base 4.2 use less
      memory than it otherwise would. */
   d4initialize( 1, 2, 50, 1000, 60000L ) ;
   w4clear(-1) ; /* Clear the screen. */

   if ( u4file_first( "CUSTOMER.DBF", match_data) == 0 )
      rc =  d4use(  "CUSTOMER" ) ;
   else
      rc =  d4create( "CUSTOMER", 7, fields, 1 ) ;
   if ( rc < 0 )  w4exit(1) ;

   if ( u4file_first( "NAME.NDX", match_data) == 0 )
      rc =  i4open( "NAME" ) ;
   else
      rc =  i4index( "NAME", "NAME", 0, 1 ) ;
   if ( rc < 0 )  w4exit(1) ;

   if ( u4file_first( "COMPANY.NDX", match_data) == 0 )
      rc =  i4open( "COMPANY" ) ;
   else
      rc =  i4index( "COMPANY", "COMPANY", 0, 1 ) ;
   if ( rc < 0 )  w4exit(1) ;

   name_ref    =  f4ref( "NAME" ) ;
   company_ref =  f4ref( "COMPANY" ) ;
   a1_ref      =  f4ref( "ADDRESS1" ) ;
   a2_ref      =  f4ref( "ADDRESS2" ) ;
   a3_ref      =  f4ref( "ADDRESS3" ) ;
   birth_ref   =  f4ref( "BIRTH_DATE" ) ;
   birth_ptr   =  f4ptr(birth_ref) ;
   sex_ref     =  f4ref( "SEX" ) ;

   ptr =  (char *) e4eval( "DATE()" ) ;
   cur_year  =  year(ptr) ;
   cur_month =  month(ptr) ;
   cur_day   =  day(ptr) ;

   b4browse( browse_setup, edit_setup ) ;

   d4close_all() ;
   w4exit(0) ;
}

